
#line 1 "ragel/smtp_date_parser.rl"

#line 8 "ragel/smtp_date_parser.rl"


#include "smtp_parsers.h"
#include "util.h"


#line 12 "date_parser.rl.c"
static const int smtp_date_parser_start = 1;
static const int smtp_date_parser_first_final = 76;
static const int smtp_date_parser_error = 0;

static const int smtp_date_parser_en_main = 1;


#line 14 "ragel/smtp_date_parser.rl"

guint64
rspamd_parse_smtp_date (const char *data, size_t len)
{
  const gchar *p = data, *pe = data + len, *eof = data + len, *tmp = data;
  struct tm tm;
  glong tz = 0;
  gint cs = 0;

  memset (&tm, 0, sizeof (tm));

  
#line 33 "date_parser.rl.c"
	{
	cs = smtp_date_parser_start;
	}

#line 26 "ragel/smtp_date_parser.rl"
  
#line 40 "date_parser.rl.c"
	{
	if ( p == pe )
		goto _test_eof;
	switch ( cs )
	{
st1:
	if ( ++p == pe )
		goto _test_eof1;
case 1:
	switch( (*p) ) {
		case 32: goto st1;
		case 70: goto st63;
		case 77: goto st67;
		case 83: goto st69;
		case 84: goto st71;
		case 87: goto st74;
	}
	if ( 48 <= (*p) && (*p) <= 57 )
		goto tr2;
	goto st0;
st0:
cs = 0;
	goto _out;
tr2:
#line 8 "ragel/smtp_date.rl"
	{
    tmp = p;
  }
	goto st2;
st2:
	if ( ++p == pe )
		goto _test_eof2;
case 2:
#line 74 "date_parser.rl.c"
	if ( (*p) == 32 )
		goto tr8;
	if ( 48 <= (*p) && (*p) <= 57 )
		goto st62;
	goto st0;
tr8:
#line 11 "ragel/smtp_date.rl"
	{
    if (p > tmp) {
      gulong n;
      if (rspamd_strtoul (tmp, p - tmp, &n)) {
        if (n > 0 && n <= 31) {
          tm.tm_mday = n;
        }
      }
    }
  }
	goto st3;
st3:
	if ( ++p == pe )
		goto _test_eof3;
case 3:
#line 97 "date_parser.rl.c"
	switch( (*p) ) {
		case 32: goto st3;
		case 65: goto st4;
		case 68: goto st37;
		case 70: goto st40;
		case 74: goto st43;
		case 77: goto st49;
		case 78: goto st53;
		case 79: goto st56;
		case 83: goto st59;
	}
	goto st0;
st4:
	if ( ++p == pe )
		goto _test_eof4;
case 4:
	switch( (*p) ) {
		case 112: goto st5;
		case 117: goto st35;
	}
	goto st0;
st5:
	if ( ++p == pe )
		goto _test_eof5;
case 5:
	if ( (*p) == 114 )
		goto st6;
	goto st0;
st6:
	if ( ++p == pe )
		goto _test_eof6;
case 6:
	if ( (*p) == 32 )
		goto tr22;
	goto st0;
tr22:
#line 110 "ragel/smtp_date.rl"
	{
    tm.tm_mon = 3;
  }
#line 21 "ragel/smtp_date.rl"
	{

  }
	goto st7;
tr70:
#line 122 "ragel/smtp_date.rl"
	{
    tm.tm_mon = 7;
  }
#line 21 "ragel/smtp_date.rl"
	{

  }
	goto st7;
tr73:
#line 134 "ragel/smtp_date.rl"
	{
    tm.tm_mon = 11;
  }
#line 21 "ragel/smtp_date.rl"
	{

  }
	goto st7;
tr76:
#line 104 "ragel/smtp_date.rl"
	{
    tm.tm_mon = 1;
  }
#line 21 "ragel/smtp_date.rl"
	{

  }
	goto st7;
tr80:
#line 101 "ragel/smtp_date.rl"
	{
    tm.tm_mon = 0;
  }
#line 21 "ragel/smtp_date.rl"
	{

  }
	goto st7;
tr83:
#line 119 "ragel/smtp_date.rl"
	{
    tm.tm_mon = 6;
  }
#line 21 "ragel/smtp_date.rl"
	{

  }
	goto st7;
tr84:
#line 116 "ragel/smtp_date.rl"
	{
    tm.tm_mon = 5;
  }
#line 21 "ragel/smtp_date.rl"
	{

  }
	goto st7;
tr88:
#line 107 "ragel/smtp_date.rl"
	{
    tm.tm_mon = 2;
  }
#line 21 "ragel/smtp_date.rl"
	{

  }
	goto st7;
tr89:
#line 113 "ragel/smtp_date.rl"
	{
    tm.tm_mon = 4;
  }
#line 21 "ragel/smtp_date.rl"
	{

  }
	goto st7;
tr92:
#line 131 "ragel/smtp_date.rl"
	{
    tm.tm_mon = 10;
  }
#line 21 "ragel/smtp_date.rl"
	{

  }
	goto st7;
tr95:
#line 128 "ragel/smtp_date.rl"
	{
    tm.tm_mon = 9;
  }
#line 21 "ragel/smtp_date.rl"
	{

  }
	goto st7;
tr98:
#line 125 "ragel/smtp_date.rl"
	{
    tm.tm_mon = 8;
  }
#line 21 "ragel/smtp_date.rl"
	{

  }
	goto st7;
st7:
	if ( ++p == pe )
		goto _test_eof7;
case 7:
#line 257 "date_parser.rl.c"
	if ( (*p) == 32 )
		goto st7;
	if ( 48 <= (*p) && (*p) <= 57 )
		goto tr24;
	goto st0;
tr24:
#line 24 "ragel/smtp_date.rl"
	{
    tmp = p;
  }
	goto st8;
st8:
	if ( ++p == pe )
		goto _test_eof8;
case 8:
#line 273 "date_parser.rl.c"
	if ( 48 <= (*p) && (*p) <= 57 )
		goto st9;
	goto st0;
st9:
	if ( ++p == pe )
		goto _test_eof9;
case 9:
	if ( (*p) == 32 )
		goto tr26;
	if ( 48 <= (*p) && (*p) <= 57 )
		goto st33;
	goto st0;
tr26:
#line 27 "ragel/smtp_date.rl"
	{
    if (p > tmp) {
      gulong n;
      if (rspamd_strtoul (tmp, p - tmp, &n)) {
        if (n < 1000) {
          tm.tm_year = n;
        }
        else {
          tm.tm_year = n - 1900;
        }
      }
    }
  }
	goto st10;
st10:
	if ( ++p == pe )
		goto _test_eof10;
case 10:
#line 306 "date_parser.rl.c"
	if ( (*p) == 32 )
		goto st10;
	if ( 48 <= (*p) && (*p) <= 57 )
		goto tr29;
	goto st0;
tr29:
#line 40 "ragel/smtp_date.rl"
	{
    tmp = p;
  }
	goto st11;
st11:
	if ( ++p == pe )
		goto _test_eof11;
case 11:
#line 322 "date_parser.rl.c"
	if ( 48 <= (*p) && (*p) <= 57 )
		goto st12;
	goto st0;
st12:
	if ( ++p == pe )
		goto _test_eof12;
case 12:
	if ( (*p) == 58 )
		goto tr31;
	goto st0;
tr31:
#line 43 "ragel/smtp_date.rl"
	{
    if (p > tmp) {
      gulong n;
      if (rspamd_strtoul (tmp, p - tmp, &n)) {
        if (n < 24) {
          tm.tm_hour = n;
        }
      }
    }
  }
	goto st13;
st13:
	if ( ++p == pe )
		goto _test_eof13;
case 13:
#line 350 "date_parser.rl.c"
	if ( 48 <= (*p) && (*p) <= 57 )
		goto tr32;
	goto st0;
tr32:
#line 53 "ragel/smtp_date.rl"
	{
    tmp = p;
  }
	goto st14;
st14:
	if ( ++p == pe )
		goto _test_eof14;
case 14:
#line 364 "date_parser.rl.c"
	if ( 48 <= (*p) && (*p) <= 57 )
		goto st15;
	goto st0;
st15:
	if ( ++p == pe )
		goto _test_eof15;
case 15:
	switch( (*p) ) {
		case 32: goto tr34;
		case 58: goto tr35;
		case 67: goto tr37;
		case 69: goto tr38;
		case 71: goto tr39;
		case 77: goto tr40;
		case 80: goto tr41;
		case 85: goto tr42;
	}
	if ( (*p) < 75 ) {
		if ( 65 <= (*p) && (*p) <= 73 )
			goto tr36;
	} else if ( (*p) > 90 ) {
		if ( (*p) > 105 ) {
			if ( 107 <= (*p) && (*p) <= 122 )
				goto tr36;
		} else if ( (*p) >= 97 )
			goto tr36;
	} else
		goto tr36;
	goto st0;
tr34:
#line 56 "ragel/smtp_date.rl"
	{
    if (p > tmp) {
      gulong n;
      if (rspamd_strtoul (tmp, p - tmp, &n)) {
        if (n < 60) {
          tm.tm_min = n;
        }
      }
    }
  }
#line 96 "ragel/smtp_date.rl"
	{
  }
	goto st16;
tr51:
#line 69 "ragel/smtp_date.rl"
	{
    if (p > tmp) {
      gulong n;
      if (rspamd_strtoul (tmp, p - tmp, &n)) {
        if (n <= 60) { /* Leap second */
          tm.tm_sec = n;
        }
      }
    }
  }
#line 96 "ragel/smtp_date.rl"
	{
  }
	goto st16;
st16:
	if ( ++p == pe )
		goto _test_eof16;
case 16:
#line 430 "date_parser.rl.c"
	switch( (*p) ) {
		case 32: goto st16;
		case 43: goto st17;
		case 45: goto st17;
	}
	goto st0;
st17:
	if ( ++p == pe )
		goto _test_eof17;
case 17:
	if ( 48 <= (*p) && (*p) <= 57 )
		goto tr45;
	goto st0;
tr45:
#line 79 "ragel/smtp_date.rl"
	{
    tmp = p;
  }
#line 82 "ragel/smtp_date.rl"
	{

  }
	goto st18;
st18:
	if ( ++p == pe )
		goto _test_eof18;
case 18:
#line 458 "date_parser.rl.c"
	if ( 48 <= (*p) && (*p) <= 57 )
		goto st19;
	goto st0;
st19:
	if ( ++p == pe )
		goto _test_eof19;
case 19:
	if ( 48 <= (*p) && (*p) <= 57 )
		goto st20;
	goto st0;
st20:
	if ( ++p == pe )
		goto _test_eof20;
case 20:
	if ( 48 <= (*p) && (*p) <= 57 )
		goto st76;
	goto st0;
st76:
	if ( ++p == pe )
		goto _test_eof76;
case 76:
	if ( (*p) == 32 )
		goto tr107;
	goto st0;
tr107:
#line 85 "ragel/smtp_date.rl"
	{
    if (p > tmp) {
      rspamd_strtoul (tmp, p - tmp, (gulong *)&tz);

      if (*(tmp - 1) == '-') {
        tz = -(tz);
      }
    }
  }
	goto st77;
tr109:
#line 94 "ragel/smtp_date.rl"
	{
  }
	goto st77;
tr112:
#line 153 "ragel/smtp_date.rl"
	{
    tz = -500;
  }
#line 94 "ragel/smtp_date.rl"
	{
  }
	goto st77;
tr113:
#line 150 "ragel/smtp_date.rl"
	{
    tz = -600;
  }
#line 94 "ragel/smtp_date.rl"
	{
  }
	goto st77;
tr116:
#line 147 "ragel/smtp_date.rl"
	{
    tz = -400;
  }
#line 94 "ragel/smtp_date.rl"
	{
  }
	goto st77;
tr117:
#line 144 "ragel/smtp_date.rl"
	{
    tz = -500;
  }
#line 94 "ragel/smtp_date.rl"
	{
  }
	goto st77;
tr119:
#line 141 "ragel/smtp_date.rl"
	{
    tz = 0;
  }
#line 94 "ragel/smtp_date.rl"
	{
  }
	goto st77;
tr122:
#line 159 "ragel/smtp_date.rl"
	{
    tz = -600;
  }
#line 94 "ragel/smtp_date.rl"
	{
  }
	goto st77;
tr123:
#line 156 "ragel/smtp_date.rl"
	{
    tz = -700;
  }
#line 94 "ragel/smtp_date.rl"
	{
  }
	goto st77;
tr126:
#line 165 "ragel/smtp_date.rl"
	{
    tz = -700;
  }
#line 94 "ragel/smtp_date.rl"
	{
  }
	goto st77;
tr127:
#line 162 "ragel/smtp_date.rl"
	{
    tz = -800;
  }
#line 94 "ragel/smtp_date.rl"
	{
  }
	goto st77;
tr129:
#line 138 "ragel/smtp_date.rl"
	{
    tz = 0;
  }
#line 94 "ragel/smtp_date.rl"
	{
  }
	goto st77;
st77:
	if ( ++p == pe )
		goto _test_eof77;
case 77:
#line 594 "date_parser.rl.c"
	if ( (*p) == 32 )
		goto st77;
	goto st0;
tr35:
#line 56 "ragel/smtp_date.rl"
	{
    if (p > tmp) {
      gulong n;
      if (rspamd_strtoul (tmp, p - tmp, &n)) {
        if (n < 60) {
          tm.tm_min = n;
        }
      }
    }
  }
	goto st21;
st21:
	if ( ++p == pe )
		goto _test_eof21;
case 21:
#line 615 "date_parser.rl.c"
	if ( 48 <= (*p) && (*p) <= 57 )
		goto tr49;
	goto st0;
tr49:
#line 66 "ragel/smtp_date.rl"
	{
    tmp = p;
  }
	goto st22;
st22:
	if ( ++p == pe )
		goto _test_eof22;
case 22:
#line 629 "date_parser.rl.c"
	if ( 48 <= (*p) && (*p) <= 57 )
		goto st23;
	goto st0;
st23:
	if ( ++p == pe )
		goto _test_eof23;
case 23:
	switch( (*p) ) {
		case 32: goto tr51;
		case 67: goto tr53;
		case 69: goto tr54;
		case 71: goto tr55;
		case 77: goto tr56;
		case 80: goto tr57;
		case 85: goto tr58;
	}
	if ( (*p) < 75 ) {
		if ( 65 <= (*p) && (*p) <= 73 )
			goto tr52;
	} else if ( (*p) > 90 ) {
		if ( (*p) > 105 ) {
			if ( 107 <= (*p) && (*p) <= 122 )
				goto tr52;
		} else if ( (*p) >= 97 )
			goto tr52;
	} else
		goto tr52;
	goto st0;
tr36:
#line 56 "ragel/smtp_date.rl"
	{
    if (p > tmp) {
      gulong n;
      if (rspamd_strtoul (tmp, p - tmp, &n)) {
        if (n < 60) {
          tm.tm_min = n;
        }
      }
    }
  }
#line 96 "ragel/smtp_date.rl"
	{
  }
	goto st78;
tr52:
#line 69 "ragel/smtp_date.rl"
	{
    if (p > tmp) {
      gulong n;
      if (rspamd_strtoul (tmp, p - tmp, &n)) {
        if (n <= 60) { /* Leap second */
          tm.tm_sec = n;
        }
      }
    }
  }
#line 96 "ragel/smtp_date.rl"
	{
  }
	goto st78;
st78:
	if ( ++p == pe )
		goto _test_eof78;
case 78:
#line 694 "date_parser.rl.c"
	if ( (*p) == 32 )
		goto tr109;
	goto st0;
tr37:
#line 56 "ragel/smtp_date.rl"
	{
    if (p > tmp) {
      gulong n;
      if (rspamd_strtoul (tmp, p - tmp, &n)) {
        if (n < 60) {
          tm.tm_min = n;
        }
      }
    }
  }
#line 96 "ragel/smtp_date.rl"
	{
  }
	goto st79;
tr53:
#line 69 "ragel/smtp_date.rl"
	{
    if (p > tmp) {
      gulong n;
      if (rspamd_strtoul (tmp, p - tmp, &n)) {
        if (n <= 60) { /* Leap second */
          tm.tm_sec = n;
        }
      }
    }
  }
#line 96 "ragel/smtp_date.rl"
	{
  }
	goto st79;
st79:
	if ( ++p == pe )
		goto _test_eof79;
case 79:
#line 734 "date_parser.rl.c"
	switch( (*p) ) {
		case 32: goto tr109;
		case 68: goto st24;
		case 83: goto st25;
	}
	goto st0;
st24:
	if ( ++p == pe )
		goto _test_eof24;
case 24:
	if ( (*p) == 84 )
		goto st80;
	goto st0;
st80:
	if ( ++p == pe )
		goto _test_eof80;
case 80:
	if ( (*p) == 32 )
		goto tr112;
	goto st0;
st25:
	if ( ++p == pe )
		goto _test_eof25;
case 25:
	if ( (*p) == 84 )
		goto st81;
	goto st0;
st81:
	if ( ++p == pe )
		goto _test_eof81;
case 81:
	if ( (*p) == 32 )
		goto tr113;
	goto st0;
tr38:
#line 56 "ragel/smtp_date.rl"
	{
    if (p > tmp) {
      gulong n;
      if (rspamd_strtoul (tmp, p - tmp, &n)) {
        if (n < 60) {
          tm.tm_min = n;
        }
      }
    }
  }
#line 96 "ragel/smtp_date.rl"
	{
  }
	goto st82;
tr54:
#line 69 "ragel/smtp_date.rl"
	{
    if (p > tmp) {
      gulong n;
      if (rspamd_strtoul (tmp, p - tmp, &n)) {
        if (n <= 60) { /* Leap second */
          tm.tm_sec = n;
        }
      }
    }
  }
#line 96 "ragel/smtp_date.rl"
	{
  }
	goto st82;
st82:
	if ( ++p == pe )
		goto _test_eof82;
case 82:
#line 805 "date_parser.rl.c"
	switch( (*p) ) {
		case 32: goto tr109;
		case 68: goto st26;
		case 83: goto st27;
	}
	goto st0;
st26:
	if ( ++p == pe )
		goto _test_eof26;
case 26:
	if ( (*p) == 84 )
		goto st83;
	goto st0;
st83:
	if ( ++p == pe )
		goto _test_eof83;
case 83:
	if ( (*p) == 32 )
		goto tr116;
	goto st0;
st27:
	if ( ++p == pe )
		goto _test_eof27;
case 27:
	if ( (*p) == 84 )
		goto st84;
	goto st0;
st84:
	if ( ++p == pe )
		goto _test_eof84;
case 84:
	if ( (*p) == 32 )
		goto tr117;
	goto st0;
tr39:
#line 56 "ragel/smtp_date.rl"
	{
    if (p > tmp) {
      gulong n;
      if (rspamd_strtoul (tmp, p - tmp, &n)) {
        if (n < 60) {
          tm.tm_min = n;
        }
      }
    }
  }
#line 96 "ragel/smtp_date.rl"
	{
  }
	goto st85;
tr55:
#line 69 "ragel/smtp_date.rl"
	{
    if (p > tmp) {
      gulong n;
      if (rspamd_strtoul (tmp, p - tmp, &n)) {
        if (n <= 60) { /* Leap second */
          tm.tm_sec = n;
        }
      }
    }
  }
#line 96 "ragel/smtp_date.rl"
	{
  }
	goto st85;
st85:
	if ( ++p == pe )
		goto _test_eof85;
case 85:
#line 876 "date_parser.rl.c"
	switch( (*p) ) {
		case 32: goto tr109;
		case 77: goto st28;
	}
	goto st0;
st28:
	if ( ++p == pe )
		goto _test_eof28;
case 28:
	if ( (*p) == 84 )
		goto st86;
	goto st0;
st86:
	if ( ++p == pe )
		goto _test_eof86;
case 86:
	if ( (*p) == 32 )
		goto tr119;
	goto st0;
tr40:
#line 56 "ragel/smtp_date.rl"
	{
    if (p > tmp) {
      gulong n;
      if (rspamd_strtoul (tmp, p - tmp, &n)) {
        if (n < 60) {
          tm.tm_min = n;
        }
      }
    }
  }
#line 96 "ragel/smtp_date.rl"
	{
  }
	goto st87;
tr56:
#line 69 "ragel/smtp_date.rl"
	{
    if (p > tmp) {
      gulong n;
      if (rspamd_strtoul (tmp, p - tmp, &n)) {
        if (n <= 60) { /* Leap second */
          tm.tm_sec = n;
        }
      }
    }
  }
#line 96 "ragel/smtp_date.rl"
	{
  }
	goto st87;
st87:
	if ( ++p == pe )
		goto _test_eof87;
case 87:
#line 932 "date_parser.rl.c"
	switch( (*p) ) {
		case 32: goto tr109;
		case 68: goto st29;
		case 83: goto st30;
	}
	goto st0;
st29:
	if ( ++p == pe )
		goto _test_eof29;
case 29:
	if ( (*p) == 84 )
		goto st88;
	goto st0;
st88:
	if ( ++p == pe )
		goto _test_eof88;
case 88:
	if ( (*p) == 32 )
		goto tr122;
	goto st0;
st30:
	if ( ++p == pe )
		goto _test_eof30;
case 30:
	if ( (*p) == 84 )
		goto st89;
	goto st0;
st89:
	if ( ++p == pe )
		goto _test_eof89;
case 89:
	if ( (*p) == 32 )
		goto tr123;
	goto st0;
tr41:
#line 56 "ragel/smtp_date.rl"
	{
    if (p > tmp) {
      gulong n;
      if (rspamd_strtoul (tmp, p - tmp, &n)) {
        if (n < 60) {
          tm.tm_min = n;
        }
      }
    }
  }
#line 96 "ragel/smtp_date.rl"
	{
  }
	goto st90;
tr57:
#line 69 "ragel/smtp_date.rl"
	{
    if (p > tmp) {
      gulong n;
      if (rspamd_strtoul (tmp, p - tmp, &n)) {
        if (n <= 60) { /* Leap second */
          tm.tm_sec = n;
        }
      }
    }
  }
#line 96 "ragel/smtp_date.rl"
	{
  }
	goto st90;
st90:
	if ( ++p == pe )
		goto _test_eof90;
case 90:
#line 1003 "date_parser.rl.c"
	switch( (*p) ) {
		case 32: goto tr109;
		case 68: goto st31;
		case 83: goto st32;
	}
	goto st0;
st31:
	if ( ++p == pe )
		goto _test_eof31;
case 31:
	if ( (*p) == 84 )
		goto st91;
	goto st0;
st91:
	if ( ++p == pe )
		goto _test_eof91;
case 91:
	if ( (*p) == 32 )
		goto tr126;
	goto st0;
st32:
	if ( ++p == pe )
		goto _test_eof32;
case 32:
	if ( (*p) == 84 )
		goto st92;
	goto st0;
st92:
	if ( ++p == pe )
		goto _test_eof92;
case 92:
	if ( (*p) == 32 )
		goto tr127;
	goto st0;
tr42:
#line 56 "ragel/smtp_date.rl"
	{
    if (p > tmp) {
      gulong n;
      if (rspamd_strtoul (tmp, p - tmp, &n)) {
        if (n < 60) {
          tm.tm_min = n;
        }
      }
    }
  }
#line 96 "ragel/smtp_date.rl"
	{
  }
	goto st93;
tr58:
#line 69 "ragel/smtp_date.rl"
	{
    if (p > tmp) {
      gulong n;
      if (rspamd_strtoul (tmp, p - tmp, &n)) {
        if (n <= 60) { /* Leap second */
          tm.tm_sec = n;
        }
      }
    }
  }
#line 96 "ragel/smtp_date.rl"
	{
  }
	goto st93;
st93:
	if ( ++p == pe )
		goto _test_eof93;
case 93:
#line 1074 "date_parser.rl.c"
	switch( (*p) ) {
		case 32: goto tr109;
		case 84: goto st94;
	}
	goto st0;
st94:
	if ( ++p == pe )
		goto _test_eof94;
case 94:
	if ( (*p) == 32 )
		goto tr129;
	goto st0;
st33:
	if ( ++p == pe )
		goto _test_eof33;
case 33:
	if ( (*p) == 32 )
		goto tr26;
	if ( 48 <= (*p) && (*p) <= 57 )
		goto st34;
	goto st0;
st34:
	if ( ++p == pe )
		goto _test_eof34;
case 34:
	if ( (*p) == 32 )
		goto tr26;
	goto st0;
st35:
	if ( ++p == pe )
		goto _test_eof35;
case 35:
	if ( (*p) == 103 )
		goto st36;
	goto st0;
st36:
	if ( ++p == pe )
		goto _test_eof36;
case 36:
	if ( (*p) == 32 )
		goto tr70;
	goto st0;
st37:
	if ( ++p == pe )
		goto _test_eof37;
case 37:
	if ( (*p) == 101 )
		goto st38;
	goto st0;
st38:
	if ( ++p == pe )
		goto _test_eof38;
case 38:
	if ( (*p) == 99 )
		goto st39;
	goto st0;
st39:
	if ( ++p == pe )
		goto _test_eof39;
case 39:
	if ( (*p) == 32 )
		goto tr73;
	goto st0;
st40:
	if ( ++p == pe )
		goto _test_eof40;
case 40:
	if ( (*p) == 101 )
		goto st41;
	goto st0;
st41:
	if ( ++p == pe )
		goto _test_eof41;
case 41:
	if ( (*p) == 98 )
		goto st42;
	goto st0;
st42:
	if ( ++p == pe )
		goto _test_eof42;
case 42:
	if ( (*p) == 32 )
		goto tr76;
	goto st0;
st43:
	if ( ++p == pe )
		goto _test_eof43;
case 43:
	switch( (*p) ) {
		case 97: goto st44;
		case 117: goto st46;
	}
	goto st0;
st44:
	if ( ++p == pe )
		goto _test_eof44;
case 44:
	if ( (*p) == 110 )
		goto st45;
	goto st0;
st45:
	if ( ++p == pe )
		goto _test_eof45;
case 45:
	if ( (*p) == 32 )
		goto tr80;
	goto st0;
st46:
	if ( ++p == pe )
		goto _test_eof46;
case 46:
	switch( (*p) ) {
		case 108: goto st47;
		case 110: goto st48;
	}
	goto st0;
st47:
	if ( ++p == pe )
		goto _test_eof47;
case 47:
	if ( (*p) == 32 )
		goto tr83;
	goto st0;
st48:
	if ( ++p == pe )
		goto _test_eof48;
case 48:
	if ( (*p) == 32 )
		goto tr84;
	goto st0;
st49:
	if ( ++p == pe )
		goto _test_eof49;
case 49:
	if ( (*p) == 97 )
		goto st50;
	goto st0;
st50:
	if ( ++p == pe )
		goto _test_eof50;
case 50:
	switch( (*p) ) {
		case 114: goto st51;
		case 121: goto st52;
	}
	goto st0;
st51:
	if ( ++p == pe )
		goto _test_eof51;
case 51:
	if ( (*p) == 32 )
		goto tr88;
	goto st0;
st52:
	if ( ++p == pe )
		goto _test_eof52;
case 52:
	if ( (*p) == 32 )
		goto tr89;
	goto st0;
st53:
	if ( ++p == pe )
		goto _test_eof53;
case 53:
	if ( (*p) == 111 )
		goto st54;
	goto st0;
st54:
	if ( ++p == pe )
		goto _test_eof54;
case 54:
	if ( (*p) == 118 )
		goto st55;
	goto st0;
st55:
	if ( ++p == pe )
		goto _test_eof55;
case 55:
	if ( (*p) == 32 )
		goto tr92;
	goto st0;
st56:
	if ( ++p == pe )
		goto _test_eof56;
case 56:
	if ( (*p) == 99 )
		goto st57;
	goto st0;
st57:
	if ( ++p == pe )
		goto _test_eof57;
case 57:
	if ( (*p) == 116 )
		goto st58;
	goto st0;
st58:
	if ( ++p == pe )
		goto _test_eof58;
case 58:
	if ( (*p) == 32 )
		goto tr95;
	goto st0;
st59:
	if ( ++p == pe )
		goto _test_eof59;
case 59:
	if ( (*p) == 101 )
		goto st60;
	goto st0;
st60:
	if ( ++p == pe )
		goto _test_eof60;
case 60:
	if ( (*p) == 112 )
		goto st61;
	goto st0;
st61:
	if ( ++p == pe )
		goto _test_eof61;
case 61:
	if ( (*p) == 32 )
		goto tr98;
	goto st0;
st62:
	if ( ++p == pe )
		goto _test_eof62;
case 62:
	if ( (*p) == 32 )
		goto tr8;
	goto st0;
st63:
	if ( ++p == pe )
		goto _test_eof63;
case 63:
	if ( (*p) == 114 )
		goto st64;
	goto st0;
st64:
	if ( ++p == pe )
		goto _test_eof64;
case 64:
	if ( (*p) == 105 )
		goto st65;
	goto st0;
st65:
	if ( ++p == pe )
		goto _test_eof65;
case 65:
	if ( (*p) == 44 )
		goto st66;
	goto st0;
st66:
	if ( ++p == pe )
		goto _test_eof66;
case 66:
	if ( (*p) == 32 )
		goto st66;
	if ( 48 <= (*p) && (*p) <= 57 )
		goto tr2;
	goto st0;
st67:
	if ( ++p == pe )
		goto _test_eof67;
case 67:
	if ( (*p) == 111 )
		goto st68;
	goto st0;
st68:
	if ( ++p == pe )
		goto _test_eof68;
case 68:
	if ( (*p) == 110 )
		goto st65;
	goto st0;
st69:
	if ( ++p == pe )
		goto _test_eof69;
case 69:
	switch( (*p) ) {
		case 97: goto st70;
		case 117: goto st68;
	}
	goto st0;
st70:
	if ( ++p == pe )
		goto _test_eof70;
case 70:
	if ( (*p) == 116 )
		goto st65;
	goto st0;
st71:
	if ( ++p == pe )
		goto _test_eof71;
case 71:
	switch( (*p) ) {
		case 104: goto st72;
		case 117: goto st73;
	}
	goto st0;
st72:
	if ( ++p == pe )
		goto _test_eof72;
case 72:
	if ( (*p) == 117 )
		goto st65;
	goto st0;
st73:
	if ( ++p == pe )
		goto _test_eof73;
case 73:
	if ( (*p) == 101 )
		goto st65;
	goto st0;
st74:
	if ( ++p == pe )
		goto _test_eof74;
case 74:
	if ( (*p) == 101 )
		goto st75;
	goto st0;
st75:
	if ( ++p == pe )
		goto _test_eof75;
case 75:
	if ( (*p) == 100 )
		goto st65;
	goto st0;
	}
	_test_eof1: cs = 1; goto _test_eof; 
	_test_eof2: cs = 2; goto _test_eof; 
	_test_eof3: cs = 3; goto _test_eof; 
	_test_eof4: cs = 4; goto _test_eof; 
	_test_eof5: cs = 5; goto _test_eof; 
	_test_eof6: cs = 6; goto _test_eof; 
	_test_eof7: cs = 7; goto _test_eof; 
	_test_eof8: cs = 8; goto _test_eof; 
	_test_eof9: cs = 9; goto _test_eof; 
	_test_eof10: cs = 10; goto _test_eof; 
	_test_eof11: cs = 11; goto _test_eof; 
	_test_eof12: cs = 12; goto _test_eof; 
	_test_eof13: cs = 13; goto _test_eof; 
	_test_eof14: cs = 14; goto _test_eof; 
	_test_eof15: cs = 15; goto _test_eof; 
	_test_eof16: cs = 16; goto _test_eof; 
	_test_eof17: cs = 17; goto _test_eof; 
	_test_eof18: cs = 18; goto _test_eof; 
	_test_eof19: cs = 19; goto _test_eof; 
	_test_eof20: cs = 20; goto _test_eof; 
	_test_eof76: cs = 76; goto _test_eof; 
	_test_eof77: cs = 77; goto _test_eof; 
	_test_eof21: cs = 21; goto _test_eof; 
	_test_eof22: cs = 22; goto _test_eof; 
	_test_eof23: cs = 23; goto _test_eof; 
	_test_eof78: cs = 78; goto _test_eof; 
	_test_eof79: cs = 79; goto _test_eof; 
	_test_eof24: cs = 24; goto _test_eof; 
	_test_eof80: cs = 80; goto _test_eof; 
	_test_eof25: cs = 25; goto _test_eof; 
	_test_eof81: cs = 81; goto _test_eof; 
	_test_eof82: cs = 82; goto _test_eof; 
	_test_eof26: cs = 26; goto _test_eof; 
	_test_eof83: cs = 83; goto _test_eof; 
	_test_eof27: cs = 27; goto _test_eof; 
	_test_eof84: cs = 84; goto _test_eof; 
	_test_eof85: cs = 85; goto _test_eof; 
	_test_eof28: cs = 28; goto _test_eof; 
	_test_eof86: cs = 86; goto _test_eof; 
	_test_eof87: cs = 87; goto _test_eof; 
	_test_eof29: cs = 29; goto _test_eof; 
	_test_eof88: cs = 88; goto _test_eof; 
	_test_eof30: cs = 30; goto _test_eof; 
	_test_eof89: cs = 89; goto _test_eof; 
	_test_eof90: cs = 90; goto _test_eof; 
	_test_eof31: cs = 31; goto _test_eof; 
	_test_eof91: cs = 91; goto _test_eof; 
	_test_eof32: cs = 32; goto _test_eof; 
	_test_eof92: cs = 92; goto _test_eof; 
	_test_eof93: cs = 93; goto _test_eof; 
	_test_eof94: cs = 94; goto _test_eof; 
	_test_eof33: cs = 33; goto _test_eof; 
	_test_eof34: cs = 34; goto _test_eof; 
	_test_eof35: cs = 35; goto _test_eof; 
	_test_eof36: cs = 36; goto _test_eof; 
	_test_eof37: cs = 37; goto _test_eof; 
	_test_eof38: cs = 38; goto _test_eof; 
	_test_eof39: cs = 39; goto _test_eof; 
	_test_eof40: cs = 40; goto _test_eof; 
	_test_eof41: cs = 41; goto _test_eof; 
	_test_eof42: cs = 42; goto _test_eof; 
	_test_eof43: cs = 43; goto _test_eof; 
	_test_eof44: cs = 44; goto _test_eof; 
	_test_eof45: cs = 45; goto _test_eof; 
	_test_eof46: cs = 46; goto _test_eof; 
	_test_eof47: cs = 47; goto _test_eof; 
	_test_eof48: cs = 48; goto _test_eof; 
	_test_eof49: cs = 49; goto _test_eof; 
	_test_eof50: cs = 50; goto _test_eof; 
	_test_eof51: cs = 51; goto _test_eof; 
	_test_eof52: cs = 52; goto _test_eof; 
	_test_eof53: cs = 53; goto _test_eof; 
	_test_eof54: cs = 54; goto _test_eof; 
	_test_eof55: cs = 55; goto _test_eof; 
	_test_eof56: cs = 56; goto _test_eof; 
	_test_eof57: cs = 57; goto _test_eof; 
	_test_eof58: cs = 58; goto _test_eof; 
	_test_eof59: cs = 59; goto _test_eof; 
	_test_eof60: cs = 60; goto _test_eof; 
	_test_eof61: cs = 61; goto _test_eof; 
	_test_eof62: cs = 62; goto _test_eof; 
	_test_eof63: cs = 63; goto _test_eof; 
	_test_eof64: cs = 64; goto _test_eof; 
	_test_eof65: cs = 65; goto _test_eof; 
	_test_eof66: cs = 66; goto _test_eof; 
	_test_eof67: cs = 67; goto _test_eof; 
	_test_eof68: cs = 68; goto _test_eof; 
	_test_eof69: cs = 69; goto _test_eof; 
	_test_eof70: cs = 70; goto _test_eof; 
	_test_eof71: cs = 71; goto _test_eof; 
	_test_eof72: cs = 72; goto _test_eof; 
	_test_eof73: cs = 73; goto _test_eof; 
	_test_eof74: cs = 74; goto _test_eof; 
	_test_eof75: cs = 75; goto _test_eof; 

	_test_eof: {}
	if ( p == eof )
	{
	switch ( cs ) {
	case 76: 
#line 85 "ragel/smtp_date.rl"
	{
    if (p > tmp) {
      rspamd_strtoul (tmp, p - tmp, (gulong *)&tz);

      if (*(tmp - 1) == '-') {
        tz = -(tz);
      }
    }
  }
	break;
	case 78: 
	case 79: 
	case 82: 
	case 85: 
	case 87: 
	case 90: 
	case 93: 
#line 94 "ragel/smtp_date.rl"
	{
  }
	break;
	case 94: 
#line 138 "ragel/smtp_date.rl"
	{
    tz = 0;
  }
#line 94 "ragel/smtp_date.rl"
	{
  }
	break;
	case 86: 
#line 141 "ragel/smtp_date.rl"
	{
    tz = 0;
  }
#line 94 "ragel/smtp_date.rl"
	{
  }
	break;
	case 84: 
#line 144 "ragel/smtp_date.rl"
	{
    tz = -500;
  }
#line 94 "ragel/smtp_date.rl"
	{
  }
	break;
	case 83: 
#line 147 "ragel/smtp_date.rl"
	{
    tz = -400;
  }
#line 94 "ragel/smtp_date.rl"
	{
  }
	break;
	case 81: 
#line 150 "ragel/smtp_date.rl"
	{
    tz = -600;
  }
#line 94 "ragel/smtp_date.rl"
	{
  }
	break;
	case 80: 
#line 153 "ragel/smtp_date.rl"
	{
    tz = -500;
  }
#line 94 "ragel/smtp_date.rl"
	{
  }
	break;
	case 89: 
#line 156 "ragel/smtp_date.rl"
	{
    tz = -700;
  }
#line 94 "ragel/smtp_date.rl"
	{
  }
	break;
	case 88: 
#line 159 "ragel/smtp_date.rl"
	{
    tz = -600;
  }
#line 94 "ragel/smtp_date.rl"
	{
  }
	break;
	case 92: 
#line 162 "ragel/smtp_date.rl"
	{
    tz = -800;
  }
#line 94 "ragel/smtp_date.rl"
	{
  }
	break;
	case 91: 
#line 165 "ragel/smtp_date.rl"
	{
    tz = -700;
  }
#line 94 "ragel/smtp_date.rl"
	{
  }
	break;
#line 1615 "date_parser.rl.c"
	}
	}

	_out: {}
	}

#line 27 "ragel/smtp_date_parser.rl"

  return rspamd_tm_to_time (&tm, tz);
}